local AddonName, GGL = ...
local GUI = GGL.GUI
local Global = {}
GGL.Options.Settings = Global

local L = GGL.Locale

-- lua

-- WoW

-- Libs
local AceGUI = LibStub("AceGUI-3.0")

-- ##################
-- local
-- ##################
local function WidgetOnRelease(self, event)

end

-- ##################
-- Settings - Top items
-- ##################
local TopItemsDbHandler

local function TopItems_NumTopItems_OnValueChanged(self, event, newValue)
    TopItemsDbHandler:Set("numTopItems", newValue)
end

local function TopItems_MinGoldValue_OnValueChanged(self, event, text)
    text = tonumber(text or 0)
    if text and text > 0 then
        text = text * 10000
        text = text > 99999999999 and 99999999999 or text
        TopItemsDbHandler:Set("minGoldValue", text)
        self:SetText(text / 10000)
    else
        TopItemsDbHandler:Set("minGoldValue", 0)
        self:SetText(0)
    end
    self:ClearFocus()
end

local function Settings_TopItems(AceGUI, container)
    TopItemsDbHandler = TopItemsDbHandler or GGL.Options:GetDbGetterAndSetter(GGL.db, "Settings", "TopItems")

    local scroll = AceGUI:Create("ScrollFrame")
    scroll:SetLayout("Flow")
    scroll:SetCallback("OnRelease", WidgetOnRelease)
    container:AddChild(scroll)

    local numTopItems = AceGUI:Create("Slider")
    numTopItems:SetFullWidth(true)
    numTopItems:SetSliderValues(1, GGL.MAX_TOP_ITEMS, 1)
    numTopItems:SetLabel(L["Maximum items shown."])
    numTopItems:SetValue(TopItemsDbHandler:Get("numTopItems"))
    numTopItems:SetCallback("OnValueChanged", TopItems_NumTopItems_OnValueChanged)
    scroll:AddChild(numTopItems)

    local minGoldValue = AceGUI:Create("EditBox")
    minGoldValue:SetFullWidth(true)
    minGoldValue:SetLabel(L["Minimum item gold value"])
    minGoldValue:SetText(TopItemsDbHandler:Get("minGoldValue") / 10000)
    minGoldValue:SetMaxLetters(7)
    minGoldValue:SetCallback("OnEnterPressed", TopItems_MinGoldValue_OnValueChanged)
    GGL.GUI:AddToolTipForAceGUIWidget(minGoldValue, L["Minimum item gold value"], L["For running session this only affects new drops."], L["A reload of the TopList can be forced with a reload of the session."])
    scroll:AddChild(minGoldValue)
end

-- Add into Options
GGL.Options:AddIntoTree(Settings_TopItems, L["Top Items"], "settings_topitems")
